
//var langs_with_pos =["da","de","en","nl","pt"];
var langs_with_pos =["en","de","pt","da","nl"];
var langs_without_pos =["af","ar","bg","bn","cs","el","es","et","fa","fi","fr","he","hi","hr","hu","id","it","ja","kn","ko","lt","lv","mk","ml","mr","ne","no","pa","pl","ro","ru","sk","sl","so","sq","sv","sw","ta","te","th","tl","tr","uk","ur","vi","zh-cn","zh-tw"];

var num_rows = 20;

function lang_pos_toggle(event) {
    var $this =$(this);
    var checked_state = $this.prop("checked");

    var id = $this.attr("id");
    var split_id = id.split("-");
    var related_id = split_id[0] + "-pos-choice";

    //console.log("checked state = " + checked_state);

    var disable_state = !checked_state;
    $('#'+related_id + " *").prop('disabled',disable_state);
};

function ajax_error(jqXHR, textStatus, errorThrown) {
    alert('An error occurred... Look at the console (F12 or Ctrl+Shift+I, Console tab) for more information!');

    console.log('jqXHR:' + jqXHR);
    console.log('textStatus:' + textStatus);
    console.log('errorThrown:' + errorThrown);
}		


function add_titles(json_data) {
    $.each( json_data, function( htid_with_prefix, htid_val ) {
	var htid = htid_with_prefix.replace(/^htid:/,"");
	
	$.each(htid_val.records, function( internalid, metadata ) {
	    var title = metadata.titles[0];
	    $("[name='"+htid+"']").each(function() {$(this).html(title)});
	    console.log(htid + ", title = " + metadata.titles[0]);
	});
    });
}

function show_new_results(delta)
{
    store_search_args.start += delta;
        
    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: store_search_args,
	dataType: 'json',
	success: show_results,
	error: ajax_error
    });
}

function show_results(jsonData) {
    var response = jsonData.response;
    var num_found = response.numFound;
    var docs = response.docs;
    var num_docs = docs.length;

    var $search_results = $('#search-results');
    if (num_docs>0) {
	$search_results.html("<p>Results: " + num_found + " volumes/documents matched</p>");
	var from = parseInt(store_search_args.start)+1;
	var to = from + num_rows;
	$search_results.append("<p>Showing matches: "+from+"-" + to + "</p>");
    }
    else {
	$search_results.html("<p>No volumes/documents matched your query</p>");
    }

    
    // https://babel.hathitrust.org/cgi/pt?id=hvd.hnnssu;view=1up;seq=11

    var htids = [];
    
    for (var i=0; i<num_docs; i++) {
	var doc = docs[i];
	var id_and_page = doc.id.split(".page-");
	var id = id_and_page[0];
	var page = parseInt(id_and_page[1]);

	
	var css_class = (i%2 == 0) ? 'class="evenline"' : 'class="oddline"';
	//var restful_safe_id = id.replace(/\./g,",").replace(/:/g, "+").replace(/\//g, "=");
	
	var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+page;

	var result_item = '<a target="_blank" href="' + babel_url + '">' + id + ', page ' + page + '</a>';
	result_item += ' <span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span>';
	$search_results.append('<p ' + css_class + '>'+result_item+'</p>');

	htids.push("htid:"+id);

    }

    document.location.href="#search-results-anchor";
    
    var next_prev = '<p style="width:100%;"><div id="search-prev" style="float: left;"><a>&lt; Previous</a></div><div id="search-next" style="float: right;"><a>Next &gt;</a></div></p>';
    
    $search_results.append(next_prev);
    $('#search-prev').click(function(event) { show_new_results(-1*num_rows); });
    $('#search-next').click(function(event) { show_new_results(num_rows); });

    var search_start = store_search_args.start;
    if (search_start==0) {
	$('#search-prev').hide();
    }
    
    // Example URL for catalog metadata (multiple items)
    // http://catalog.hathitrust.org/api/volumes/brief/json/id:552;lccn:70628581|isbn:0030110408

    var htids_str = htids.join("|",htids);
    var cat_url = "http://catalog.hathitrust.org/api/volumes/brief/json/" + htids_str;
    	$.ajax({
	    url: cat_url,
	    dataType: 'jsonp',
	    jsonpCallback: "add_titles"
	});


    //var json_pretty = JSON.stringify(jsonData.response, null, '\t');
    //$('#search-results').text(json_pretty)
}

var store_search_args = null;
var store_search_action = null;

function submit_action(event)
{
    event.preventDefault();

    store_search_action = $('#search-form').attr("action");
    
    var arg_indent = $('#indent').attr('value');
    var arg_wt     = $('#wt').attr('value');
    var arg_start  = $('#start').attr('value');
    var arg_rows   = $('#rows').attr('value');
    var q_text     = $('#q').val();
    
    if (q_text === "") {
	alert("No query term entered");
	return;
    }
    
    var fields = [];
    //var langs_with_pos = [ "da", "de", "en", "nl", "pt", "se" ];
    var universal_pos_tags = [ "VERB", "NOUN", "ADJ", "ADV", "ADP", "CONJ", "DET", "NUM", "PRT", "X" ];
    
    for (var li=0; li<langs_with_pos.length; li++) {
	var lang = langs_with_pos[li];
	var lang_enabled_id = lang + "-enabled";
	var $lang_enabled_cb = $('#'+lang_enabled_id);
	if ($lang_enabled_cb.is(':checked')) {
	    console.log("Extracting POS tags for: " + lang);
	    
	    for (var ti=0; ti<universal_pos_tags.length; ti++) {
		var tag = universal_pos_tags[ti];
		var lang_tag_id = lang+"-"+tag+"-htrctoken-cb";
		var $lang_tag_cb = $('#'+lang_tag_id);
		if ($lang_tag_cb.is(':checked')) {
		    var lang_tag_field = "xxxx"+lang+"_"+tag+"_htrctoken";
		    fields.push(lang_tag_field+":"+q_text);
		}
	    }
	}
    }

    for (var li=0; li<langs_without_pos.length; li++) {
	var lang = langs_without_pos[li];
	var lang_enabled_id = lang + "-enabled";
	var $lang_enabled_cb = $('#'+lang_enabled_id);

	if ($lang_enabled_cb.is(':checked')) {
	    console.log("Adding in non-POS field for: " + lang);
	    var lang_tag_field = "xxxx"+lang+"_htrctoken";
	    fields.push(lang_tag_field+":"+q_text);	    
	}
    }

    if (fields.length == 0) {
	alert("No languages selected");
	return;
    }
    
    var arg_q = fields.join(" OR ");
    
    
    // Example search on one of the htrc-full-ef fields is: 
    //  q=xxxxen_NOUN_htrctoken:farming
    
    store_search_args = { q: arg_q, indent: arg_indent, wt: arg_wt, start: arg_start, rows: arg_rows };
    
    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: store_search_args,
	dataType: 'json',
	success: show_results,
	error: ajax_error
    });

}

function generate_pos_langs()
{
    var pos_checkbox = [
	{ pos:"VERB", label:"Verbs",       tooltip:"Verbs (all tenses and modes)" },
	{ pos:"NOUN", label:"Nouns",       tooltip:"Nouns (common and proper)" },
	{ pos:"ADJ",  label:"Adjectives",  tooltip: null }, 
	{ pos:"ADV",  label:"Adverbs",     tooltip: null },
	{ pos:"ADP",  label:"Adpositions", tooltip:"Adpositions (prepositions and postpositions)" },
	{ pos:"CONJ", label:"Conjunctions",tooltip: null },
	{ pos:"DET",  label:"Determiners", tooltip: null },
	{ pos:"NUM",  label:"Numbers",     tooltip:"Cardinal numbers" },
	{ pos:"PRT",  label:"Particles",   tooltip:"Particles or other function words" },
	{ pos:"X",    label:"Other",       tooltip:"Other words, such as foreign words, typos, abbreviations"}
    ];

    var $pos_fieldsets = $('#pos-fieldsets');
    
    for (var li=0; li<langs_with_pos.length; li++) {

	var l = langs_with_pos[li];
	var lang_full = isoLangs[l].name;
	var lang_native_full = isoLangs[l].nativeName;
	var opt_title = (lang_full !== lang_native_full) ? 'title="'+lang_native_full+'"' : "";

	var opt_enabled = (l == "en") ? 'checked="checked"' : "";
	
	var legend = "";
	legend += '    <legend style="margin-bottom: 5px; padding-top: 15px;">\n';
	legend += '      <input type="checkbox" name="'+l+'-enabled" id="'+l+'-enabled" ' + opt_enabled +'/>\n';
	legend += '      <span ' + opt_title + '>'+lang_full+':</span>\n';
	legend += '    </legend>\n';
	

	var check_box_list = [];
	    
	for (var pi=0; pi<pos_checkbox.length; pi++) {
	    var pos_info = pos_checkbox[pi];
	    var pos = pos_info.pos;
	    var label = pos_info.label;
	    var tooltip = pos_info.tooltip;
	    var opt_tooltip = (tooltip != null) ? 'title="'+tooltip+'"' : "";
	    
	    var check_box = "";
	    check_box += '    <input type="checkbox" name="'+l+'-'+pos+'-htrctoken-cb" id="'+l+'-'+pos+'-htrctoken-cb" checked="checked" />\n';
	    check_box += '    <label for="'+l+'-'+pos+'-htrctoken-cb" '+opt_tooltip+'>'+label+'</label>\n';

	    check_box_list.push(check_box);
	}
	
	var fieldset = "";
	fieldset += '<fieldset>\n';
	fieldset += legend;
	fieldset += '  <div id="'+l+'-pos-choice">\n';

	var check_box_join = check_box_list.join('&nbsp;');
	fieldset += check_box_join;
	
	fieldset += '  </div>\n';
	fieldset += '</fieldset>\n';
	
	$pos_fieldsets.append(fieldset);
	$('#'+l+'-enabled').click(lang_pos_toggle);

	if (l == "en") {
	    $('#en-pos-choice *').prop('disabled',false);
	}
	else {
	    $('#'+l+'-pos-choice *').prop('disabled',true);
	}
    }


    //$('#en-enabled').click(lang_pos_toggle);
    //$('#de-enabled').click(lang_pos_toggle);
    //$('#de-pos-choice *').prop('disabled',true);
}

function generate_other_langs()
{
    // setup other languages
    // for each 'langs_without_pos' generate HTML of the form:
    //    <input type="checkbox" name="fr-enabled" id="fr-enabled" />French
    var $other_langs = $('#other-langs');

    for (var i=0; i<langs_without_pos.length; i++) {
	var lang = langs_without_pos[i];
	//var labeled_checkbox = '<span style="white-space:nowrap;">\n';
	var labeled_checkbox = '<nobr>';
	
	labeled_checkbox += '<input type="checkbox" name="'+lang+'-enabled" id="'+lang+'-enabled" />';
	/*
	if (lang === "zh-cn") {
	    console.log("Mapping zh-cn => zh");
	    lang = "zh";
	}
	if (lang === "zh-tw") {
	    console.log("Mapping zh-tw => zh");
	    lang = "zh";
	}
*/
	var lang_full = isoLangs[lang].name;
	var lang_native_full = isoLangs[lang].nativeName;
	var opt_title = (lang_full !== lang_native_full) ? 'title="'+lang_native_full+'"' : "";
	
	labeled_checkbox += '<label for="'+lang+'-enabled" style="padding-left: 5px; padding-right: 10px;" ' + opt_title + '>'+lang_full+'</label>';
	//labeled_checkbox += '</span>\n';
	labeled_checkbox += '</nobr> ';
	
	$other_langs.append(labeled_checkbox);
	
    }
}

$(function() {
    generate_pos_langs();

    generate_other_langs();
    
    $('#search-submit').click(submit_action);

});
